var serverSystem = server.registerSystem(0, 0);
var globalVars = { tick: 0, pos: [], toKill: [] };

serverSystem.initialize = function () {
    globalVars.viewAllEntities = this.registerQuery();
    this.listenForEvent("minecraft:entity_death", (eventData) => this.onDeath(eventData));
};

serverSystem.onDeath = function (eventData) {
    if (eventData.entity.__identifier__ === "minecraft:player" && globalVars.pos[eventData.entity.id] !== null) {
        let beforePos = globalVars.pos[eventData.entity.id];
        let entity = this.createEntity("entity", "betterdeath:death");
        this.applyComponentChanges(entity, beforePos);
        globalVars.toKill.push([entity.id, 20]);
    }
}

serverSystem.update = function () {
    globalVars.tick = globalVars.tick + 1;
    if (globalVars.tick === 20) {
        let allEntities = serverSystem.getEntitiesFromQuery(globalVars.viewAllEntities);
        let size = allEntities.length;
        for (let index = 0; index < size; ++index) {
            if (allEntities[index].__identifier__ === "minecraft:player") {
                let position = this.getComponent(allEntities[index], "minecraft:position");
                if (position !== null) {
                    globalVars.pos[allEntities[index].id] = position;
                }
            }
        }
        for (var k in globalVars.toKill) {
            var value = globalVars.toKill[k];
            if(value[1] === 20){
                for (let index = 0; index < size; ++index) {
                    if (allEntities[index].__identifier__ === "betterdeath:death" && allEntities[index].id === value[0]) {
                        this.destroyEntity(allEntities[index])
                        delete globalVars.toKill[k];
                    }
                }
            }
        }
        globalVars.tick = 0;
    }
}

